--
-- Addon for moveable Farmerarm
-- Addon für beweglichen Farmerarm
--
-- @author Aranea
-- @date  01/02/2013
-- @update  27/08/2014
-- @update  15/11/2016 by Mythos
--
-- @v1.0 basic
-- @v1.1 update
--
-- Copyright (C) Aranea, All Rights Reserved.
--

FarmerArm = {};

function FarmerArm.prerequisitesPresent(specializations)
	return true;
end;

function FarmerArm:load(savegame)
	self.MPArm = SpecializationUtil.callSpecializationsFunction("MPArm");
	self.leftArm = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#leftArm"));
	self.rightArm = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#rightArm"));
	self.body = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#body"));
	self.index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#index"));
	
	setVisibility(self.leftArm, false);
	setVisibility(self.rightArm, false);
	setVisibility(self.body, false);
	setVisibility(self.index, false);
end;

function FarmerArm:postLoad(savegame)
end;

function FarmerArm:delete()
end;

function FarmerArm:readStream(streamId, connection)
end;

function FarmerArm:writeStream(streamId, connection)
end;

function FarmerArm:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FarmerArm:keyEvent(unicode, sym, modifier, isDown)
end;

function FarmerArm:update(dt)

	if self.isEntered then
		if self.camIndex==2 then
			self:MPArm(2);
		else
			self:MPArm(1);
		end;
	end;

end;

function FarmerArm:updateTick(dt)
end;

function FarmerArm:draw()
end;

function FarmerArm:onEnter()
	
end;

function FarmerArm:onLeave()
	setVisibility(self.leftArm, false);
	setVisibility(self.rightArm, false);
	setVisibility(self.body, false);
	setVisibility(self.index, false);
end;

function FarmerArm:MPArm(mode, noEventSend)
	ArmEvent.sendEvent(self, mode, noEventSend);
	if mode == 2 then
		setVisibility(self.leftArm, true);
		setVisibility(self.rightArm, true);
		setVisibility(self.body, true);
		setVisibility(self.index, false);
	elseif mode == 1 then
		setVisibility(self.leftArm, true);
		setVisibility(self.rightArm, true);
		setVisibility(self.body, true);
		setVisibility(self.index, true);
	end;
end;

--**********************************************************************************************************************************************************************************
ArmEvent = {};
ArmEvent_mt = Class(ArmEvent, Event);

InitEventClass(ArmEvent, "ArmEvent");

function ArmEvent:emptyNew()
    local self = Event:new(ArmEvent_mt);
    self.className="ArmEvent";
    return self;
end;

function ArmEvent:new(vehicle, mode)
    local self = ArmEvent:emptyNew()
    self.vehicle = vehicle;
	self.mode = mode;
    return self;
end;

function ArmEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.mode = streamReadInt32(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function ArmEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, self.mode);
end;

function ArmEvent:run(connection)
	self.vehicle:MPArm(1, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(ArmEvent:new(self.vehicle, 1), nil, connection, self.vehicle);
    end;
end;

function ArmEvent.sendEvent(vehicle, mode, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ArmEvent:new(vehicle, mode), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(ArmEvent:new(vehicle, mode));
		end;
	end;
end;
